Attribute VB_Name = "basHttpDown"
Public Declare Function InternetSetStatusCallback Lib "wininet.dll" (ByVal hInternetSession As Long, ByVal lpfnInternetCallback As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Public complientEV As Long
'Constants - CallbackProc.dwInternetStatus
Private Const INTERNET_STATUS_RESOLVING_NAME = 10
Private Const INTERNET_STATUS_NAME_RESOLVED = 11
Private Const INTERNET_STATUS_CONNECTING_TO_SERVER = 20
Private Const INTERNET_STATUS_CONNECTED_TO_SERVER = 21
Private Const INTERNET_STATUS_SENDING_REQUEST = 30
Private Const INTERNET_STATUS_REQUEST_SENT = 31
Private Const INTERNET_STATUS_RECEIVING_RESPONSE = 40
Private Const INTERNET_STATUS_RESPONSE_RECEIVED = 41
'Private Const INTERNET_STATUS_CTL_RESPONSE_RECEIVED = 42
'Private Const INTERNET_STATUS_PREFETCH = 43
'Private Const INTERNET_STATUS_CLOSING_CONNECTION = 50
'Private Const INTERNET_STATUS_CONNECTION_CLOSED = 51
Private Const INTERNET_STATUS_HANDLE_CREATED = 60
Private Const INTERNET_STATUS_HANDLE_CLOSING = 70
Private Const INTERNET_STATUS_REQUEST_COMPLETE = 100

Public Sub CallbackProc(ByVal hInternet As Long, _
                        ByVal dwContext As Long, _
                        ByVal dwInternetStatus As Long, _
                        ByRef lpvStatusInformation As Long, _
                        ByVal dwStatusInformationLength As Long)

    'Get the Status Information
    Select Case dwInternetStatus

        Case INTERNET_STATUS_HANDLE_CREATED
            Debug.Print "dwInternetStatus:"; dwInternetStatus
            CopyMemory ByVal (dwContext + 4), lpvStatusInformation, 4
        
        Case INTERNET_STATUS_RESOLVING_NAME
            Debug.Print "dwInternetStatus:"; dwInternetStatus

        Case INTERNET_STATUS_NAME_RESOLVED
            Debug.Print "dwInternetStatus:"; dwInternetStatus

        Case INTERNET_STATUS_CONNECTING_TO_SERVER
            Debug.Print "dwInternetStatus:"; dwInternetStatus

        Case INTERNET_STATUS_CONNECTED_TO_SERVER
            Debug.Print "dwInternetStatus:"; dwInternetStatus

        Case INTERNET_STATUS_SENDING_REQUEST
            Debug.Print "dwInternetStatus:"; dwInternetStatus

        Case INTERNET_STATUS_REQUEST_SENT
            Debug.Print "dwInternetStatus:"; dwInternetStatus

        Case INTERNET_STATUS_RECEIVING_RESPONSE
            Debug.Print "dwInternetStatus:"; dwInternetStatus

        Case INTERNET_STATUS_RESPONSE_RECEIVED
            Debug.Print "dwInternetStatus:"; dwInternetStatus

        Case INTERNET_STATUS_HANDLE_CLOSING
            Debug.Print "dwInternetStatus:"; dwInternetStatus;

        Case INTERNET_STATUS_REQUEST_COMPLETE
            Debug.Print "dwInternetStatus:"; dwInternetStatus
            CopyMemory ByVal (dwContext + 8), dwInternetStatus, 4
            SetEvent complientEV

        Case Else
            Debug.Print "dwInternetStatus:"; dwInternetStatus

    End Select

    DoEvents
End Sub
