VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsHttpDown"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function InternetOpen Lib "wininet.dll" Alias "InternetOpenA" (ByVal lpszCallerName As String, ByVal dwAccessType As Long, ByVal lpszProxyName As String, ByVal lpszProxyBypass As String, ByVal dwFlags As Long) As Long
Private Declare Function InternetOpenUrl Lib "wininet" Alias "InternetOpenUrlA" (ByVal hInternetSession As Long, ByVal lpszUrl As String, ByVal lpszHeaders As String, ByVal dwHeadersLength As Long, ByVal dwFlags As Long, ByVal dwContext As Long) As Long
Private Declare Function InternetReadFileEx Lib "wininet.dll" Alias "InternetReadFileExA" (ByVal hFile As Long, ByRef lpBuffersOut As INTERNET_BUFFERS, ByVal dwFlags As Long, ByVal dwContext As Long) As Long
Private Declare Function InternetCloseHandle Lib "wininet.dll" (ByVal hInternetHandle As Long) As Boolean
'Private Declare Function GetLastError Lib "kernel32" () As Long

Private Type INTERNET_BUFFERS
  dwStructSize As Long
  Next As Long
  lpcszHeader As Long ' LPCTSTR
  dwHeadersLength As Long
  dwHeadersTotal As Long
  lpvBuffer As Long ' LPVIOD
  dwBufferLength As Long
  dwBufferTotal As Long
  dwOffsetLow As Long
  dwOffsetHigh As Long
End Type

'Constants - InternetOpen.dwAccessType
Private Const INTERNET_OPEN_TYPE_PRECONFIG = 0

'Constants - FtpFindFirstFile.dwFlags
Private Const INTERNET_FLAG_NO_CACHE_WRITE = &H4000000
Private Const INTERNET_FLAG_RELOAD = &H80000000
Private Const INTERNET_FLAG_PRAGMA_NOCACHE = &H100

'Constants - InternetOpen.dwFlags
Private Const INTERNET_FLAG_ASYNC = 1 '&H10000000

'Constants - HttpQueryInfo.dwInfoLevel
Private Const HTTP_QUERY_CONTENT_LENGTH = 5

'Constants - Overlapped I/O operation is in progress.
Private Const ERROR_IO_PENDING = 997

Private Const BUFFER_LEN = 1024
' Variable to hold 'extName' property value
Private m_StrextName As String

Public Property Get extName() As String
    extName = m_StrextName
End Property

Public Property Let extName(ByVal StrValue As String)
    m_StrextName = StrValue
End Property

Public Function GetHttpResource(sURL As String) As Boolean

    Dim intFile       As Integer

    Dim hSession      As Long

    Dim hInternet     As Long

    Dim varData()     As Byte
    Dim h             As Long
    Dim strBuffer     As String * BUFFER_LEN

    Dim OutBuffer     As INTERNET_BUFFERS
    
    Dim lngContext(2) As Long

    
    hSession = InternetOpen("vb wininet", INTERNET_OPEN_TYPE_PRECONFIG, vbNullString, vbNullString, INTERNET_FLAG_ASYNC)
    Debug.Print "hSession:"; hSession

    If hSession <> 0 Then
        complientEV = CreateEvent(ByVal 0&, 0, 0, 0)
      
        Call InternetSetStatusCallback(hSession, AddressOf CallbackProc)
       
        hInternet = InternetOpenUrl(hSession, sURL, vbNullString, 0, INTERNET_FLAG_RELOAD Or INTERNET_FLAG_PRAGMA_NOCACHE Or INTERNET_FLAG_NO_CACHE_WRITE, ByVal VarPtr(lngContext(0)))

        If Err.LastDllError = ERROR_IO_PENDING Then
      
            Do

                If lngContext(2) = 100 Then Exit Do
                ResetEvent complientEV
                h = WaitForSingleObject(complientEV, 100)
               
                DoEvents
            Loop While h = WAIT_TIMEOUT

            lngContext(2) = 0
            Debug.Print "complete ---" & lngContext(2)
         
            hInternet = lngContext(1)
            
        End If

        Debug.Print "Err.LastDllError:"; Err.LastDllError
        Debug.Print "hInternet:"; hInternet

        If hInternet <> 0 Then
            ReDim varData(BUFFER_LEN - 1) As Byte
            intFile = FreeFile
            Randomize
            Open App.Path + "\new" & CStr(Int(Rnd() * 9999)) & "." & m_StrextName For Binary Access Write As #intFile
            OutBuffer.dwStructSize = Len(OutBuffer)
            OutBuffer.dwBufferLength = BUFFER_LEN
            OutBuffer.lpvBuffer = VarPtr(varData(0))
            lngContext(2) = 0
            Do

                If Not InternetReadFileEx(hInternet, OutBuffer, INTERNET_FLAG_ASYNC, 0&) Then
                    If Err.LastDllError = ERROR_IO_PENDING Then
                        Do

                            If lngContext(2) = 100 Then Exit Do
                            ResetEvent complientEV
                            h = WaitForSingleObject(complientEV, 100)
               
                            DoEvents
                        Loop While h = WAIT_TIMEOUT

                        lngContext(2) = 0

                    End If

                End If

                If OutBuffer.dwBufferLength > 0 Then
                    If OutBuffer.dwBufferLength <> 0 And OutBuffer.dwBufferLength <> BUFFER_LEN Then
                        ReDim Preserve varData(OutBuffer.dwBufferLength - 1) As Byte

                    End If

                    Put #intFile, , varData
                Else
                    Exit Do

                End If

            Loop
            GetHttpResource = True
            Close #intFile
            Call InternetCloseHandle(hInternet)
            Debug.Print "hInternet:"; hInternet; "- Closed"

        End If

        Call InternetCloseHandle(hSession)
        'Call InternetSetStatusCallback(hSession, 0)
        Debug.Print "hSession:"; hSession; "- Closed"
        
    Else
        Exit Function

    End If
    
End Function

Private Sub Class_Initialize()
    m_StrextName = "JPG"
End Sub
