Attribute VB_Name = "myTime"

' --------------------------------------------------------------------------------------
Option Explicit

Private Declare Function QueryPerformanceCounter Lib "kernel32" (lpPerformanceCount As Currency) As Long
Private Declare Function QueryPerformanceFrequency Lib "kernel32" (lpFrequency As Currency) As Long

Private mcurQueryPerformanceFrequency As Currency
Private mcurQueryPerformanceRuntime As Currency
Private mcurTimeStart As Currency

'
' --------------------------------------------------------------------------------------

Private Sub ModuleInitialize()
' 
    Dim curCount1 As Currency, curCount2 As Currency
    
    QueryPerformanceFrequency mcurQueryPerformanceFrequency
    
    QueryPerformanceCounter curCount1
    QueryPerformanceCounter curCount2
    mcurQueryPerformanceRuntime = curCount2 - curCount1

End Sub


' --------------------------------------------------------------------------------------
Public Sub myTimeStart()
    QueryPerformanceCounter mcurTimeStart
End Sub

Public Function myTimeLeft() As Currency
    
    Dim curNow As Currency
    
    QueryPerformanceCounter curNow
    
    If mcurTimeStart = Empty Then
        myTimeLeft = -1
    Else
        If mcurQueryPerformanceFrequency = Empty Then Call ModuleInitialize
        myTimeLeft = (curNow - mcurTimeStart - mcurQueryPerformanceRuntime) / mcurQueryPerformanceFrequency
    End If
    
End Function

